function cpu_dump(d, prg_size, prg_size_dummy)
{
	if(prg_size==0x4000)
		cpu_read(d, 0xc000, 0x4000);
	else//32k
		cpu_read(d, 0x8000, 0x8000);
}
function cpu_erase(d, prg_size, prg_size_dummy)
{	
	cpu_write_flash(d,0x8555,0xF0);
	cpu_write_flash(d,0x8555,0xAA);
	cpu_write_flash(d,0x8AAA,0x55);
	cpu_write_flash(d,0x8555,0x80);
	cpu_write_flash(d,0x8555,0xAA);
	cpu_write_flash(d,0x8AAA,0x55);
	cpu_write_flash(d,0x8555,0x10);
}
function cpu_flash(d, prg_size, prg_size_dummy)
{
	flash_configure(d,0x8000,0x8555,0x82AA,0x8555);
	
	if(prg_size==0x4000)
		prg_flash(d, 0xc000, 0x4000);
	else//32k
		prg_flash(d, 0x8000, 0x8000);
}
function ppu_dump(d, chr_size, crc)
{
	if(0xF99BFCC1==crc)//Buggy Popper (Japan)
	{
		cpu_write(d, 0x809C, 0);
		//8225 33
		for(local i = 0; i < chr_size/0x2000; i+=1){
			cpu_write(d, 0x8222+i, i+0x30);
			ppu_read(d,0x0000, 0x2000);
		}
	}
	else if(0x5CB00D24==crc)//Hanafuda Yuukyou Den - Nagarebana Oryuu
	{
		for(local i = 0; i < chr_size/0x2000; i+=1){
			cpu_write(d, 0x80ae+i, i+8);
			ppu_read(d,0x0000, 0x2000);
		}
	}
	else if(0x3636F632==crc)//ASO: Armored Scrum Object 
	{
		for(local i = 0; i < chr_size/0x2000; i+=1){
			cpu_write(d, 0x8255, 0x30+i);
			cpu_write(d, 0x8255, 0x30+i);
			ppu_read(d,0x0000, 0x2000);
		}
	}
	else if(0xe8175c0c==crc)//Gradius (Japan)
	{
		show_log(d, "dump Gradius");
		cpu_write(d, 0x8ACE+0, 0x30+0);
		cpu_write(d, 0x8ACE+0, 0x30+0);		
		ppu_read(d,0x0000, 0x2000);
		
		cpu_write(d, 0x8ACE+2, 0x30+1);
		cpu_write(d, 0x8ACE+2, 0x30+1);		
		ppu_read(d,0x0000, 0x2000);
		
		cpu_write(d, 0x8ACE+1, 0x30+2);
		cpu_write(d, 0x8ACE+1, 0x30+2);		
		ppu_read(d,0x0000, 0x2000);
		
		cpu_write(d, 0x8ACE+3, 0x30+3);
		cpu_write(d, 0x8ACE+3, 0x30+3);		
		ppu_read(d,0x0000, 0x2000);
		
		
	}
	else if(0xF4027304==crc)//Mickey Mouse - Fushigi no Kuni no Daibouken (Japan)
	{
		for(local i = 0; i < chr_size/0x2000; i+=1){
			cpu_write(d, 0xDB9A+i, 0x30+i);
			cpu_write(d, 0xDB9A+i, 0x30+i);
			ppu_read(d,0x0000, 0x2000);
		}
	}
	else{
		show_log(d, "dump normal mapper3");
		for(local i = 0; i < chr_size/0x2000; i+=1){
			cpu_write(d, 0x8000+i, i+0x30);
			cpu_write(d, 0x9000+i, i+0x30);
			cpu_write(d, 0xF000+i, i+0x30);
			ppu_read(d,0x0000, 0x2000);
		}
	}
}

function ppu_erase(d, chr_size, chr_size_dummy)
{
	ppu_write(d,0x1555,0xF0);
	ppu_write(d,0x1555,0xAA);
	ppu_write(d,0x12AA,0x55);
	ppu_write(d,0x1555,0x80);
	ppu_write(d,0x1555,0xAA);
	ppu_write(d,0x12AA,0x55);
	ppu_write(d,0x1555,0x10);
}
function ppu_flash(d, chr_size, chr_size_dummy)
{
	flash_configure(d,0x1555,0x1555,0x12AA,0x1555);
	for(local i = 0; i < chr_size/0x2000; i+=1){
		cpu_write(d, 0xC000, i);
		chr_flash(d,0x0000, 0x2000);
	}
}